import {Card} from "./Card";
import {getRandomNumber} from "./RandomNumber";

export class Deck {
    private RANKS: string[] = ["2", "3", "4", "5", "6", "7", "8", "9", "10", "J", "Q", "K", "A"]
    private SUITS: string[] = ["♠", "♥", "♦", "♣"]
    private _cards: Card[] = [];
    private tookCardIndexes: number[] = [];

    constructor() {
        for (let i = 0; i < this.RANKS.length; i++) {
            for (let j = 0; j < this.SUITS.length; j++) {
                this._cards.push(new Card(this.RANKS[i], this.SUITS[j]))
            }
        }
        console.log("New deck has been created.")
    }

    shuffleDeck() {
        for (let i = this._cards.length - 1; i > 0; i--) {
            const j = Math.floor(Math.random() * (i + 1));
            [this._cards[i], this._cards[j]] = [this._cards[j], this._cards[i]];
        }
        console.log("The deck has been shuffled!")
    }

    takeACardFromDeck() {
        const ranNum: number = getRandomNumber(0, this._cards.length + 1);
        if (!this.tookCardIndexes.includes(ranNum)) {
            return this._cards[ranNum];
            this.tookCardIndexes.push(ranNum);
            console.log(`You took ${this.tookCardIndexes.length} from the deck`)
        }
        this.takeACardFromDeck();
    }
}