import {Card} from "./Card";

export class Hand {
    set holdingCards(value: Card[]) {
        this._holdingCards = value;
    }

    get holdingCards(): Card[] {
        return this._holdingCards;
    }

    private _limit: number = 5;
    private _holdingCards: Card[] = [];
    private _changeCounter: number = 5;

    receiveCard(card: Card) {
        if (this._holdingCards.length < this._limit) {
            this._holdingCards.push(card)
            console.log(`You received ${this._holdingCards.length} cards.`)
        } else {
            console.log("Hand is full!")
        }
    }

    showCards() {
        for (let i = 0; i < this._holdingCards.length; i++) {
            console.log(this._holdingCards[i].show(i + 1))
            console.log("==============")
        }
    }

    changeCard(newCard: Card, i: number) {
        if (i > 6 && i > 0) return console.log("Card number can not be more then 5 and less then 1")
        if (this._changeCounter) {
            this._holdingCards[i - 1] = newCard;
            console.log("Card has been changed!")
            this._changeCounter--
        } else {
            console.log("You've already changed 5 times.")
        }
    }
}